#ifndef SRLIST
#define SRLIST

struct _SrEntry {
    char            *name;
    void            *extra_data; 
    struct _SrEntry *next;
    };
typedef struct _SrEntry SrEntry;

typedef struct _SrList SrList;
struct _SrList {
    int     hash_size;
    SrEntry **table;
    int (*HashFn)( SrList *, char * );
    void (*destroy)( SrList * );
    int (*Lookup)( SrList *, char *, SrEntry **);
    int (*Insert)( SrList *, char *, SrEntry **);
    int (*Delete)( SrList *, char * );
    int (*Walk)( SrList *, int (*)( char *, SrEntry *, void * ), void * );
    };

SrList *NewSrList( int );

#endif
